/*-
 * Copyright (c) 2010 Andriy Gapon <avg@FreeBSD.Org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#ifndef _AVG_FS_H_
#define _AVG_FS_H_

#define	AVG_ROOTDIR_INO		1
#define	AVG_THEFILE_INO		2
#define AVG_THEFILE_NAME	"thefile"

#define	VFSTOAVGFS(mp)	((struct avg_mnt *)((mp)->mnt_data))
#define	VTON(vp)	((struct avg_node *)((vp)->v_data))

MALLOC_DECLARE(M_AVGFS);

struct avg_mnt
{
	int			im_flags;
	struct mount		*im_mountp;
	struct g_consumer	*im_cp;
	struct bufobj		*im_bo;
	struct cdev		*im_dev;
	struct vnode		*im_devvp;
	off_t			size;
	int			bsize;
	int			bshift;
	int			bmask;
	int			use_devvp;
};

struct avg_node
{
	struct vnode	*i_vnode;
	struct avg_mnt	*avgmp;
	ino_t		hash_id;
};

struct ifid {
	u_short	ifid_len;
	u_short	ifid_pad;
	int	ifid_ino;
	long	ifid_start;
};

int avg_allocv(struct mount *, struct vnode **, struct thread *);
int avg_vget(struct mount *, ino_t, int, struct vnode **);

#endif
